//
// WtScroller.js
//
// Copyright  2005, glenn andreas.	 All rights reserved
//

protoDynamicVerticalScrollbar = View({
	_proto : protoView,
	viewClass : 'scrollbar',
	chromeWidth : 19,
	viewStyle : {
		appleDashboardRegion : "dashboard-region(control rectangle);"
	},
	value : 0.0,
	lineHeight : 20,
	AdjustScrollbar : function() {
		if (!this.content) {
			this.Hide();
			return;
		}
		this.Show();
		var currentContentStyle = document.defaultView.getComputedStyle(this.content.viewElement,'');
		if (!currentContentStyle) return; // if not visible, can't compute
		var currentContentTop = parseInt(currentContentStyle.getPropertyValue('top'));
		var currentContentHeight = parseInt(currentContentStyle.getPropertyValue('height'));
		var viewHeight = parseFloat (document.defaultView.getComputedStyle(this.content.viewElement.parentNode, '').getPropertyValue('height')); // the clip it is in
		if (viewHeight >= currentContentHeight) {
			this.thumb.Hide();
			// and make sure we're at the top
			this.content.viewElement.style.top = 0;
			this.value = 0.0;
		} else {
			if (currentContentTop > viewHeight - currentContentHeight) {
				currentContentTop = viewHeight - currentContentHeight;
				this.content.viewElement.style.top = currentContentTop;
			}
			this.thumb.Show();
			this.thumb.ResizeThumb( Math.floor(this.viewElement.offsetHeight * (viewHeight / currentContentHeight) ), this.value);
		}
	},
	AdjustView : function() {
		var currentContentStyle = document.defaultView.getComputedStyle(this.content.viewElement,'');
		if (!currentContentStyle) return; // if not visible, can't compute
		var currentContentTop = parseInt(currentContentStyle.getPropertyValue('top'));
		var currentContentHeight = parseInt(currentContentStyle.getPropertyValue('height'));
		var viewHeight = parseFloat (document.defaultView.getComputedStyle(this.content.viewElement.parentNode, '').getPropertyValue('height')); // the clip it is in
		if (viewHeight >= currentContentHeight) {
			this.content.viewElement.style.top = 0;
		} else {
			this.content.viewElement.style.top = -((currentContentHeight - viewHeight) * this.value);
		}
	},
	ScrollTo : function(value) {
		if (value < 0.0) { value = 0.0; }
		if (value > 1.0) { value = 1.0; }
		this.value = value;
		if (this.thumb.viewFlags & vVisible) {
			this.thumb.MoveThumb(value);
			this.AdjustView();
		}
	},
	ViewChangedScript : function(symbol,value) {
		if (symbol == 'content') {
			// update the scrollbar
			this.AdjustScrollbar();
		} else if (symbol == 'value') {
			ScrollTo(this.value);
		}
	},
	ReorientToScreen : function() {
		// change our size
		protoView.ReorientToScreen.call(this); // reorient children
		var self = this;
		var adjustLater = function() {
			var currentContentStyle = document.defaultView.getComputedStyle(self.content.viewElement,'');
			if (!currentContentStyle) return; // if not visible, can't compute
			var currentContentTop = parseInt(currentContentStyle.getPropertyValue('top'));
			var currentContentHeight = parseInt(currentContentStyle.getPropertyValue('height'));
			var viewHeight = parseFloat (document.defaultView.getComputedStyle(self.content.viewElement.parentNode, '').getPropertyValue('height')); // the clip it is in
			if (viewHeight >= currentContentHeight) {
				self.thumb.Hide();
				self.content.viewElement.style.top = 0;
				self.value = 0.0;
			} else {
				if (currentContentTop > viewHeight - currentContentHeight) {
					//currentContentTop = viewHeight - currentContentHeight;
					//self.content.viewElement.style.top = currentContentTop;
				} else {
				}
				self.content.viewElement.style.top = -((currentContentHeight - viewHeight) * self.value);
				//self.thumb.Hide();
				self.thumb.ResizeThumb( Math.floor(self.viewElement.offsetHeight * (viewHeight / currentContentHeight) ), self.value);
				//self.thumb.Show();
			}
		}
		setTimeout(adjustLater, 0);
	},
	ViewScrollDownScript : function() {
		if (this.value < 1.0) {
			var currentContentStyle = document.defaultView.getComputedStyle(this.content.viewElement,'');
			if (!currentContentStyle) return; // if not visible, can't compute
			var currentContentTop = parseInt(currentContentStyle.getPropertyValue('top'));
			var currentContentHeight = parseInt(currentContentStyle.getPropertyValue('height'));
			var viewHeight = parseFloat (document.defaultView.getComputedStyle(this.content.viewElement.parentNode, '').getPropertyValue('height')); // the clip it is in
			if (viewHeight >= currentContentHeight) {
			} else {
				this.ScrollTo(this.value + this.lineHeight / (currentContentHeight - viewHeight));
			}
		}
	},
	ViewScrollUpScript : function() {
		if (this.value > 0.0) {
			var currentContentStyle = document.defaultView.getComputedStyle(this.content.viewElement,'');
			if (!currentContentStyle) return; // if not visible, can't compute
			var currentContentTop = parseInt(currentContentStyle.getPropertyValue('top'));
			var currentContentHeight = parseInt(currentContentStyle.getPropertyValue('height'));
			var viewHeight = parseFloat (document.defaultView.getComputedStyle(this.content.viewElement.parentNode, '').getPropertyValue('height')); // the clip it is in
			if (viewHeight >= currentContentHeight) {
			} else {
				this.ScrollTo(this.value - this.lineHeight / (currentContentHeight - viewHeight));
			}
		}
	}
});

// a vertical bar with endcaps and repeated middle
protoVerticalBar = View({
	_proto : protoView,
	viewClass : 'verticalBar',
	chromeWidth	 : 16,
	chromeTopOffset : 0,
	chromeBottomOffset : 0,
	chromeTopHeight : 16,
	chromeBottomHeight : 16,
	chromeImages : ["top.png", "middle.png", "bottom.png"],
	CreateElement : function() {
		var retval = protoView.CreateElement.call(this);
		var slice = document.createElement('DIV');
		slice.style.position = 'absolute';
		slice.style.width = this.chromeWidth;
		slice.style.height = this.chromeTopHeight;
		slice.style.top = this.chromeTopOffset;
		slice.style.background = 'url("' + this.chromeImages[0] + '") no-repeat top left';
		retval.appendChild(slice);
		slice = document.createElement('DIV');
		slice.style.position = 'absolute';
		slice.style.width = this.chromeWidth;
		slice.style.top = this.chromeTopOffset + this.chromeTopHeight;
		slice.style.bottom = this.chromeBottomOffset + this.chromeBottomHeight;
		slice.style.background = 'url("' + this.chromeImages[1] + '") repeat-y top left';
		retval.appendChild(slice);
		slice = document.createElement('DIV');
		slice.style.position = 'absolute';
		slice.style.width = this.chromeWidth;
		slice.style.height = this.chromeBottomHeight;
		slice.style.bottom = this.chromeBottomOffset;
		slice.style.background = 'url("' + this.chromeImages[2] + '") no-repeat bottom left';
		retval.appendChild(slice);
		return retval;
	}
});

protoDynamicScrollbarThumb = View({
	_proto : protoVerticalBar,
	viewClass : 'scrollbarThumb',
	viewStyle : {
		position: 'absolute'
	},
	chromeWidth : 18,
	chromeTopOffset : -1,
	chromeTopHeight : 9,
	chromeBottomHeight : 9,
	viewFlags : protoVerticalBar.viewFlags | vClickable,
	chromeImages: ['WtChrome/scroll_bar_top.png', 'WtChrome/scroll_bar_mid.png', 'WtChrome/scroll_bar_bottom.png'],
	ViewClickScript : function(event) {
		this.Drag(event, this._parent.GlobalBox());
	},
	ViewDraggedScript : function(newX, newY) {
		var percent = this.viewElement.offsetTop / (this.viewElement.offsetParent.offsetHeight - this.viewElement.offsetHeight);
		this._parent.value = percent;
		this._parent.AdjustView();
	},
	ResizeThumb : function(size,  percent) {
		//this.viewBounds.height = size;
		//this.viewBounds.bottom = this.viewBounds.top + size;
		this.viewElement.style.bottom = 'auto';
		if (size < this.chromeTopHeight + this.chromeBottomHeight) {
			size = this.chromeTopHeight + this.chromeBottomHeight;
		}
		if (size < parseFloat(this.viewElement.style)) {
			// make smaller - resize before moving
			this.viewElement.style.height = size;
			this.viewElement.style.top = (this.viewElement.offsetParent.offsetHeight - this.viewElement.offsetHeight) * percent;
		} else {
			// make larger, move before resizing
			this.viewElement.style.top = (this.viewElement.offsetParent.offsetHeight - this.viewElement.offsetHeight) * percent;
			this.viewElement.style.height = size;
		}
	},
	MoveThumb : function(percent) {
		if (this.viewElement.offsetParent) {
			this.viewElement.style.top = (this.viewElement.offsetParent.offsetHeight - this.viewElement.offsetHeight) * percent;
		}
	}
});

protoDynamicScrollbarTrack = View({
	_proto : protoVerticalBar,
	chromeWidth : 19,
	chromeTopHeight : 18,
	chromeBottomHeight : 18,
	chromeImages: ['WtChrome/top_scroll_track.png', 'WtChrome/mid_scroll_track.png', 'WtChrome/bottom_scroll_track.png'],
	ViewClickScript : function(event) {
		this.TrackButton(event);
	}
});

DeclareChild(protoDynamicScrollbarTrack, protoDynamicVerticalScrollbar, "track");
DeclareChild(protoDynamicScrollbarThumb, protoDynamicVerticalScrollbar, "thumb");


protoClipper = View({
	_proto : protoView,
	viewClass : 'clipper',
	viewStyle : {
		overflow:'hidden'
	}
});

